<?php

/**
@Shows the gateway form and starts a transaction!
*/
function ocart_print_ideal_form($post_id, $location = '') {
	
global $ocart;

require_once PLUGIN_OCART_IDEAL_PATH.'Mollie/iDEAL/Payment.php';

$partner_id  = $ocart['ideal_partnerid']; // Uw mollie partner ID
$gatewayprofilekey = $ocart['ideal_profile_key'];
$amount      = ocart_payable($post_id);   // Het af te rekenen bedrag in centen (!!!)
$description = sprintf(__('%s Payment for Invoice %s','ocart'), get_bloginfo('name'), $post_id); // Beschrijving die consument op zijn/haar afschrift ziet.
$invoiceid = $post_id;

$return_url  = PLUGIN_OCART_IDEAL_URL.'return.php'; // URL waarnaar de consument teruggestuurd wordt na de betaling
$report_url  = PLUGIN_OCART_IDEAL_URL.'report.php?invoiceid='.urlencode($invoiceid); // URL die Mollie aanvraagt (op de achtergrond) na de betaling om de status naar op te sturen

if (!in_array('ssl', stream_get_transports()))
{
	echo "<h1>Foutmelding</h1>";
	echo "<p>Uw PHP installatie heeft geen SSL ondersteuning. SSL is nodig voor de communicatie met de Mollie iDEAL API.</p>";
	exit;	
}

$iDEAL = new Mollie_iDEAL_Payment ($partner_id);
$iDEAL->setProfileKey($gatewayprofilekey);

if (isset($ocart['ideal_testmode']) && $ocart['ideal_testmode'] == 1) {
	$iDEAL->setTestmode();
}

if (isset($_POST['bank_id']) and !empty($_POST['bank_id'])) 
{

	$idealAmount = $amount*100;

	if ($iDEAL->createPayment($_POST['bank_id'], $idealAmount, $description, $return_url, $report_url)) 
	{
		/* Hier kunt u de aangemaakte betaling opslaan in uw database, bijv. met het unieke transactie_id
		   Het transactie_id kunt u aanvragen door $iDEAL->getTransactionId() te gebruiken. Hierna wordt 
		   de consument automatisch doorgestuurd naar de gekozen bank. */
		
		header("Location: " . $iDEAL->getBankURL());
		exit;	
	}
	else 
	{
		/* Er is iets mis gegaan bij het aanmaken bij de betaling. U kunt meer informatie 
		   vinden over waarom het mis is gegaan door $iDEAL->getErrorMessage() en/of 
		   $iDEAL->getErrorCode() te gebruiken. */
		
		echo '<p>De betaling kon niet aangemaakt worden.</p>';
		
		echo '<p><strong>Foutmelding:</strong> ', htmlspecialchars($iDEAL->getErrorMessage()), '</p>';
		exit;
	}
}


/*
  Hier worden de mogelijke banken opgehaald en getoont aan de consument.
*/

$bank_array = $iDEAL->getBanks();

if ($bank_array == false)
{
	echo '<p>Er is een fout opgetreden bij het ophalen van de banklijst: ', $iDEAL->getErrorMessage(), '</p>';
	exit;
}

?>

<form class="cform" method="post" action="<?php echo PLUGIN_OCART_IDEAL_URL.'prepare.php'; ?>">

	<fieldset>
	<legend><?php _e('iDEAL via Mollie','ocart'); ?></legend>
		<p>
			<label for="bank_id"><?php _e('Choose your bank','ocart'); ?></label>
			<select name="bank_id" id="bank_id">
				<option value=''><?php _e('Choose your bank','ocart'); ?></option>
				<?php foreach ($bank_array as $bank_id => $bank_name) { ?>
				<option value="<?php echo htmlspecialchars($bank_id) ?>"><?php echo htmlspecialchars($bank_name) ?></option>
				<?php } ?>
			</select>
		</p>
	</fieldset>
	
	<p class="submit">
		<input type="submit" name="submit" value="<?php _e('Betaal via iDEAL','ocart'); ?>" />
	</p>
	
	<input type="hidden" name="amount" id="amount" value="<?php echo $amount; ?>" />
	<input type="hidden" name="description" id="description" value="<?php echo $description; ?>" />
	<input type="hidden" name="invoiceid" id="invoiceid" value="<?php echo $invoiceid; ?>" />
	
</form>

<?php
}