<?php

define( 'WP_USE_THEMES', false );
require('../../../wp-load.php');

global $ocart;

require_once PLUGIN_OCART_IDEAL_PATH.'Mollie/iDEAL/Payment.php';

$partner_id  = $ocart['ideal_partnerid']; // Uw mollie partner ID
$gatewayprofilekey = $ocart['ideal_profile_key'];
$amount      = $_POST['amount'];   // Het af te rekenen bedrag in centen (!!!)
$description = $_POST['description']; // Beschrijving die consument op zijn/haar afschrift ziet.
$invoiceid = $_POST['invoiceid'];

$return_url  = PLUGIN_OCART_IDEAL_URL.'return.php'; // URL waarnaar de consument teruggestuurd wordt na de betaling
$report_url  = PLUGIN_OCART_IDEAL_URL.'report.php?invoiceid='.urlencode($invoiceid); // URL die Mollie aanvraagt (op de achtergrond) na de betaling om de status naar op te sturen

if (!in_array('ssl', stream_get_transports()))
{
	echo "<h1>Foutmelding</h1>";
	echo "<p>Uw PHP installatie heeft geen SSL ondersteuning. SSL is nodig voor de communicatie met de Mollie iDEAL API.</p>";
	exit;	
}

$iDEAL = new Mollie_iDEAL_Payment ($partner_id);
$iDEAL->setProfileKey($gatewayprofilekey);

if (isset($ocart['ideal_testmode']) && $ocart['ideal_testmode'] == 1) {
	$iDEAL->setTestmode();
}

if (isset($_POST['bank_id']) and !empty($_POST['bank_id'])) 
{

	$idealAmount = $amount*100;

	if ($iDEAL->createPayment($_POST['bank_id'], $idealAmount, $description, $return_url, $report_url)) 
	{
		/* Hier kunt u de aangemaakte betaling opslaan in uw database, bijv. met het unieke transactie_id
		   Het transactie_id kunt u aanvragen door $iDEAL->getTransactionId() te gebruiken. Hierna wordt 
		   de consument automatisch doorgestuurd naar de gekozen bank. */
		
		header("Location: " . $iDEAL->getBankURL());
		exit;	
	}
	else 
	{
		/* Er is iets mis gegaan bij het aanmaken bij de betaling. U kunt meer informatie 
		   vinden over waarom het mis is gegaan door $iDEAL->getErrorMessage() en/of 
		   $iDEAL->getErrorCode() te gebruiken. */
		
		echo '<p>De betaling kon niet aangemaakt worden.</p>';
		
		echo '<p><strong>Foutmelding:</strong> ', htmlspecialchars($iDEAL->getErrorMessage()), '</p>';
		exit;
	}
}


/*
  Hier worden de mogelijke banken opgehaald en getoont aan de consument.
*/

$bank_array = $iDEAL->getBanks();

if ($bank_array == false)
{
	echo '<p>Er is een fout opgetreden bij het ophalen van de banklijst: ', $iDEAL->getErrorMessage(), '</p>';
	exit;
}